"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var VuexModule = /** @class */ (function () {
    function VuexModule(module) {
        this.actions = module.actions;
        this.mutations = module.mutations;
        this.state = module.state;
        this.getters = module.getters;
        this.namespaced = module.namespaced;
        this.modules = module.modules;
    }
    return VuexModule;
}());
exports.VuexModule = VuexModule;
function moduleDecoratorFactory(modOrOpt) {
    return function (constructor) {
        var module = constructor;
        var state = new (module.prototype.constructor)({});
        if (!module.state) {
            module.state = {};
        }
        if (!module.getters) {
            module.getters = {};
        }
        module.namespaced = modOrOpt && modOrOpt.namespaced;
        Object.keys(state).forEach(function (key) {
            if (state.hasOwnProperty(key)) {
                if (typeof state[key] !== 'function') {
                    module.state[key] = state[key];
                }
            }
        });
        Object.getOwnPropertyNames(module.prototype).forEach(function (funcName) {
            var descriptor = Object.getOwnPropertyDescriptor(module.prototype, funcName);
            if (descriptor.get) {
                module.getters[funcName] = function (moduleState) { return descriptor.get.call(module.state); };
            }
        });
    };
}
function Module(modOrOpt) {
    if (typeof modOrOpt === 'function') {
        /*
         * @Module({...}) decorator called with options
         */
        moduleDecoratorFactory({})(modOrOpt);
    }
    else {
        /*
         * @Module decorator called without options (directly on the class definition)
         */
        return moduleDecoratorFactory(modOrOpt);
    }
}
exports.Module = Module;
//# sourceMappingURL=module.js.map